<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Did you applied manure recently ?</translate>
            </div>
            <q-btn-toggle
              v-model="storeDidAppliedManure"
              :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
              toggle-color="primary"
            />
          </q-card-section>
          <q-card-section>
            <template v-if="storeDidAppliedManure">
              <div
                class="text-body2 q-mb-md"
              >
                <translate>Indicate the last manure you applied</translate>:
              </div>
              <q-select
                v-model="storeManure"
                :options="vegsystManureOptions"
                option-value="id"
                option-label="source"
                filled
                :loading="!hasLoadedManure"
                :label="$gettext('Select a manure')"
                class="q-mb-md"
              />
              <DateSelectorInput
                v-model="storeManureApplicationDate"
                :date-options="applicationDateOptions"
                :hint="$gettext('Date of the most recent manure application')"
                class="q-mb-md"
              />
              <q-input
                :model-value="storeManureVolume"
                filled
                type="number"
                :label="$gettext('Volume of manure applied')"
                :suffix="$pgettext('unit', 'm3/ha')"
                :rules="rulesPositiveOrNullNumber"
                :min="volumeManureAppliedMin"
                :max="volumeManureAppliedMax"
                @update:model-value="value => storeManureVolume = value < volumeManureAppliedMin ? volumeManureAppliedMin : value > volumeManureAppliedMax ? volumeManureAppliedMax : Math.abs(value)"
                hide-bottom-space
                :loading="!hasLoadedInputsControl"
              />
            </template>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { date } from 'quasar'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VegsystMixin from 'src/pages/fieldbook/fertilization/algorithms/vegsyst/mixins/VegsystMixin'
import queryVegsystManure from 'src/pages/fieldbook/fertilization/algorithms/vegsyst/graphql/queryVegsystManure'
import DateSelectorInput from 'src/components/form/DateSelectorInput'

const { formatDate } = date

export default {
  name: 'VegsystManurePage',
  components: {
    GenericLayout,
    Header,
    Footer,
    DateSelectorInput
  },
  mixins: [PlatformMixin, DateMixin, AlgorithmsMixins, VegsystMixin],
  data () {
    return {
      hasLoadedManure: false,
      vegsystManures: [],
      notApplicable: false
    }
  },
  computed: {
    canContinue () {
      return this.storeDidAppliedManure != null &&
        (this.storeDidAppliedManure === false ||
        (
          this.storeManure != null &&
          this.storeManureApplicationDate != null &&
          this.storeManureVolume != null
        ))
    },
    pageTitle () {
      return this.$gettext('Manure')
    },
    pageSubTitle () {
      return 'VegSyst'
    },
    rulesPositiveNumber () {
      return [
        val => val != null || `* ${this.$gettext('This field is required')}`,
        val => val > 0 || `${this.$gettext('This field must be positive')}`
      ]
    },
    rulesPositiveOrNullNumber () {
      return [
        val => val != null || `* ${this.$gettext('This field is required')}`,
        val => val >= 0 || `${this.$gettext('This field must be positive')}`
      ]
    },
    storeDidAppliedManure: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.didAppliedManure
      },
      set (v) {
        this.updateParameter('didAppliedManure', v)
      }
    },
    storeManure: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.manure
      },
      set (v) {
        this.updateParameter('manure', v)
      }
    },
    storeManureApplicationDate: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.manureApplicationDate
      },
      set (v) {
        this.updateParameter('manureApplicationDate', v)
      }
    },
    storeManureVolume: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.manureVolume
      },
      set (v) {
        this.updateParameter('manureVolume', v)
      }
    },
    vegsystManureOptions () {
      return this.vegsystManures.map(manure => {
        return {
          ...manure
        }
      })
    },
    volumeManureAppliedMin () {
      if (this.hasLoadedInputsControl) {
        return this.vegsystInputsControl?.manure_volume?.min_value ?? undefined
      } else {
        return undefined
      }
    },
    volumeManureAppliedMax () {
      if (this.hasLoadedInputsControl) {
        return this.vegsystInputsControl?.manure_volume?.max_value ?? undefined
      } else {
        return undefined
      }
    }
  },
  apollo: {
    vegsystManures: {
      query: queryVegsystManure,
      notifyOnNetworkStatusChange: true,
      update (data) {
        this.hasLoadedManure = true
        return data.vegsyst__manure
      }
    }
  },
  methods: {
    applicationDateOptions (date) {
      return date <= formatDate(new Date(), 'YYYY/MM/DD')
    },
    onClickNext () {
      if (this.storeDidAppliedManure === false) {
        // Set dummy data since manure data are required for the recommendation calculation
        this.storeManure = this.vegsystManures[0]
        this.storeManureApplicationDate = new Date()
        this.storeManureVolume = 0
      }
      this.$router.push({
        name: 'vegsystIrrigationLayoutPage'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'vegsystSoilPage'
      })
    },
    onInputControlQueryUpdate (inputControls) {
      // set default values if necessary:
      // manure volume
      if (this.storeManureVolume == null && inputControls?.manure_volume?.default_value != null) {
        this.storeManureVolume = inputControls.manure_volume.default_value
      }
    }
  }
}
</script>
